    ;; YaPPP 0.7 - Yet Another PPP.  Based on Thomas Neuhaus' PPP.
    ;; Copyright (C) 2013 Emanuel Wittersheim

    ;; This program is free software: you can redistribute it and/or modify
    ;; it under the terms of the GNU General Public License as published by
    ;; the Free Software Foundation, either version 3 of the License, or
    ;; (at your option) any later version.

    ;; This program is distributed in the hope that it will be useful,
    ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;; GNU General Public License for more details.

    ;; You should have received a copy of the GNU General Public License
    ;; along with this program.  If not, see <http://www.gnu.org/licenses/>.



(define (read-file inputfile nr-of-columns)
  (define (read-file-line n)
    (define (helper result rest)
      (if (= 0 rest)
          (reverse result)
          (helper (cons (read) result) (- rest 1))))
    (helper '() n))
  (with-input-from-file inputfile
    (lambda ()
      (define (helper result)
	(let ((line (read-file-line nr-of-columns)))
	  (if (eof-object? (car line))
	      (reverse result)
	      (helper (cons line result)))))
      (helper '()))))

(define (columns-to-lines ls)
  (define (helper result rest)
    (if (null? (car rest))
        (reverse result)
        (helper (cons (map car rest) result) 
                (map cdr rest))))
  (helper '() ls))

;; Aus Praat werden alle P-Felder abgesehen von den Dauern generiert.
;; Die Dauern (p3) müssen getrennt generiert werden (wie auch immer).
;; Die Dauern Liste wird in die p-feld-Liste einsortiert. 

(define (sort-in ls ll ref)
  (define (loop vorne hinten anz)
    (cond ((> ref (length ll))
	   (error "Value REF out of Range!"))
	  ((= anz ref)
	   (append vorne (cons ls hinten)))
	  (else
	   (let ((neu (list-ref ll anz)))
	     (loop (append vorne (list neu))
		   (cdr hinten)
		   (+ anz 1))))))
  (loop '() ll 0))


(define (trns-or-shft ll proc v)
  (let loop ((ll ll)
	     (erg '()))
    (if (null? ll)
	(reverse erg)
	(loop (cdr ll)
	      (cons (map (lambda (x) (proc x v))
			 (car ll)) erg)))))

;; (trns-or-shft '((1 2 3 4)(5 6 7 8)) - 100)

;;(define analyse-pfields (columns-to-lines (read-file "formants_treppengelander_quietsch08_100113.txt" 5)))

;; (with-output-to-file "filename"
;;   (lambda ()
;;     (let ((anz (length (car analyse-pfields))))
;;       (write-score 
;;        (append (list (tendency 0.0 1.0 20.0 26.0 anz))
;;                (append (list (konstante 3.5 anz))
;;                        (trns-or-shft (cdr analyse-pfields) * 0.5)))))))

(newline)
(display "YaPPP 0.7 Copyright (C) 2013 Emanuel Wittersheim
	This program comes with ABSOLUTELY NO WARRANTY. For details see file COPYING. 
	This is free software, and you are welcome to redistribute it
	under certain conditions.")
(newline)
