    ;; YaPPP 0.7 - Yet Another PPP.  Based on Thomas Neuhaus' PPP.
    ;; Copyright (C) 2013 Emanuel Wittersheim

    ;; This program is free software: you can redistribute it and/or modify
    ;; it under the terms of the GNU General Public License as published by
    ;; the Free Software Foundation, either version 3 of the License, or
    ;; (at your option) any later version.

    ;; This program is distributed in the hope that it will be useful,
    ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;; GNU General Public License for more details.

    ;; You should have received a copy of the GNU General Public License
    ;; along with this program.

;; (load "ugens_180113.scm")

(define ScorelineMaker
  (lambda  p_procs
    (lambda msg
      (case (car msg)
	((type) "ScoreLine Maker")
	((next)  (map (lambda (x) (send x 'next (cadr msg)))
		      p_procs))
	(else (delegate base-object msg))))))

(define (write-score)
  (define (write-score-inner)
    (define (to-score  instr time line)
      (display "i ")
      (display instr)
      (display " ")
      (display (round1000 time))
      (for-each (lambda (x) (display " ") (display (round1000 x)))
		(cddr line))
      (newline))
    (define (loop)
      (cond ((< (send TIME 'show) (send MAX_TIME 'show))
	     (let* ((this_line (send scoreline 'next (send TIME 'show)))
		    (instr (list-ref this_line 0))
		    (ed (list-ref this_line 1))
		    (this_time (send TIME 'show)))
	       (send TIME 'update! (+ this_time ed))
	       (to-score  instr this_time this_line)
	       (loop)))
	    (else 
	     (send TIME 'reset!))))
    (loop))
  (cond ((<= (send COUNT_TRACKS 'show) (send TRACKS 'show))
	 (let ((this_count (send COUNT_TRACKS 'show)))
	   (write-score-inner)
	   (send COUNT_TRACKS 'update! (+ this_count 1))
	   (write-score)))
	(else (display "e")
	      (newline)
	      (send TRACKS 'reset!)
	      (send COUNT_TRACKS 'reset!))))

 
(define (run_csound aiff_file orc_file sco_file)
  (define (to-file filename)
    (with-output-to-file (string-append filename ".sco")
      (lambda ()
	(write-score))))
  (let ((call 
	 (string-append "csound -Ado " aiff_file ".aiff " orc_file ".orc " sco_file ".sco")))
    (to-file sco_file)))
;;    (system call)))


(newline)
(display "YaPPP 0.7 Copyright (C) 2013 Emanuel Wittersheim
	This program comes with ABSOLUTELY NO WARRANTY. For details see file COPYING. 
	This is free software, and you are welcome to redistribute it
	under certain conditions.")
(newline)
